/* backl.h     v0.1  (C) 1999 adolfo@di-mare.com */

/* Traverses a list backward, from its last to
   its first element */

#ifndef   BACKL_H
#define   BACKL_H

#ifdef __cplusplus
extern "C" {
#endif

#include "list.h"
#include "iterator.h"

#ifndef iterator_list_
    define_itr_vmt(list, lpos);
    #define iterator_list_
#endif

typedef struct list_backward_ {
    char  mark[12];
    itr_vmt(list);
    list * L;
    lpos * v;
    size_t index, count;
} list_backward;

void init_backward(list_backward *);

void bind_backward(     iterator(list) *I , list *L);
int  finished_backward( iterator(list) *I );
lpos here_backward(     iterator(list) *I );
void next_backward(     iterator(list) *I );
void done_backward(     iterator(list) *I );

#ifdef __cplusplus
}
#endif

#endif /* BACKL_H */
/* EOF:   backl.h */
