/* forwl.c     v0.1  (C) 1999 adolfo@di-mare.com */

#include "forwl.h"
#include <mem.h>

void init_forward(list_forward *I) {
    memcpy(I->mark, "Init", 12);
    I->vmt.bind     = bind_forward;
    I->vmt.finished = finished_forward;
    I->vmt.here     = here_forward;
    I->vmt.next     = next_forward;
    I->vmt.done     = done_forward;

    I->L = NULL;
    I->p = NULL;
}

void bind_forward( iterator(list) *I_vmt , list *L) {
    list_forward *I = vmt_self(list_forward, I_vmt);
    memcpy(I->mark, "bind", 12);

    I->p = list_first(&(*L));
    I->L = L;
}

int finished_forward( iterator(list) *I_vmt ) {
    list_forward *I = vmt_self(list_forward, I_vmt);
    memcpy(I->mark, "finished", 12);

    return (NULL == I->p);
}

lpos here_forward( iterator(list) *I_vmt ) {
    list_forward *I = vmt_self(list_forward, I_vmt);
    memcpy(I->mark, "here", 12);

    return I->p;
}

void next_forward( iterator(list) *I_vmt ) {
    list_forward *I = vmt_self(list_forward, I_vmt);
    memcpy(I->mark,  "next", 12);

    I->p = list_next(I->L, I->p);
}

void done_forward( iterator(list) *I_vmt ) {
    #pragma argsused
    /* do nothing destructor */
}

/* EOF: forwl.c */
