/* forwl.h     v0.1  (C) 1999 adolfo@di-mare.com */

/* Traverses a list forward, from its first to
   its last element */

#ifndef   FORWL_H
#define   FORWL_H

#ifdef __cplusplus
extern "C" {
#endif

#include "list.h"
#include "iterator.h"

#ifndef iterator_list_
    define_itr_vmt(list, lpos);
    #define iterator_list_
#endif

typedef struct list_forward_ {
    char  mark[12];
    list * L;
    lpos   p;       /* here() */
    itr_vmt(list);
} list_forward;

void init_forward(list_forward *);

void bind_forward(     iterator(list) *I , list *L);
int  finished_forward( iterator(list) *I );
lpos here_forward(     iterator(list) *I );
void next_forward(     iterator(list) *I );
void done_forward(     iterator(list) *I );

#ifdef __cplusplus
}
#endif

#endif /* FORWL_H */
/* EOF:   forwl.h */
